<template>
  <div v-if="userName">
    <a
      :class="`badge ${hoverColor}`"
      v-bind:href="userHref"
      target="_blank"
    >
      <img
        :src="src"
        :alt="alt"
        :width="width"
        :title="$t('social.socialAltTextImg', { name })"
      >
      <a
        class="pl-2"
        :title="$t('social.socialAltTextA', { name })"
      >
        @{{ usernameToDisplay }}
      </a>
    </a>
  </div>
  
</template>

<script>
import { parseUser } from '../utils'

const keepOnlyNCharacters = (maxLength, string) => {
  if (string.length > maxLength) {
    const start = string.substr(0, maxLength/2)
    const end = string.substr(-maxLength/2, maxLength/2)
    return `${start}...${end}`
  } else {
    return string
  }
}

export default {
  name: 'SocialMediaPageUserLink',
  props: [
    'name',
    'userName',
    'hoverColor',
    'userHref',
    'src',
    'alt',
    'width'
  ],
  setup (props) {
    const maxLength = 30
    const usernameToDisplay = keepOnlyNCharacters(
      maxLength, parseUser(props.userName || '')
    )
    return {
      usernameToDisplay
    }
  }
}
</script>

<style lang="postcss" scoped>
.badge{
  @apply inline-flex items-center;
  @apply py-1 px-3 mr-3 mb-3;
  @apply text-xs text-white;
  @apply rounded;
  @apply bg-gray-400;
  @apply hover:text-yellow-200;
  @apply duration-150;
}
</style>